/* $Id: openfile.c,v 1.3 2000/10/10 22:10:44 dps Exp $ */
/* Open a file in /proc in complete paranioa mode */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif /* HAVE_CONFIG_H */
#ifdef HAVE_ERRNO_H
#include <errno.h>
#endif /* HAVE_ERRNO_H */
#ifdef HAVE_SYS_TYPES_H
#include <sys/types.h>
#endif /* HAVE_SYS_TYPES_H */
#ifdef HAVE_SYS_STAT_H
#include <sys/stat.h>
#endif /* HAVE_SYS_STAT_H */
#ifdef HAVE_FCNTL_H
#include <fcntl.h>
#endif /* HAVE_FCNTL_H */
#include "prog.h"
#include "libdetail/detail.h"

FILE *open_proc_obj(const char *fname, const int fmt)
{
    FILE *res;
    int fd;
    struct stat stbuf;
#if defined(HAVE_STATFS) && defined(CPS_PROC_FS_TYPE) && defined(STATFS_WORKS)
    struct statfs fts;
#endif

    /* First open the file */
    if ((fd=open(fname, O_RDONLY))==-1)
    {
	do_log("Could not open %s (errno  %d aka. %s)", fname, errno, strerror(errno));
	return NULL;
    }
    /* This is very paranoid by we *need* paranioa here IMHO. */
#if defined(HAVE_STATFS) && defined(CPS_PROC_FS_TYPE) && defined(STATFS_WORKS)
    if (fstatfs(fileno(f), &fts)!=0)
    {
	do_log("Unexpected failure of statfs (error %d)", errno);
	close(fd);
	return NULL;
    }
    if (fts.f_type!=CPS_PROC_FS_TYPE)
    {
	do_log("Uh. Uh. Detected hacking attempt: wrong fs type!");
	close(fd);
	return NULL;
    }
#endif /* HAVE_STATFS and STATFS_FST and STATFS_WORKS */
    inode_cache(fname, stbuf.st_ino, stbuf.st_dev, stbuf.st_mtime, 0);

    if (fstat(fd, &stbuf)!=0)
    {
	do_log("Unexpected fauilure of fstat (errno %d aka. %s)", errno, strerror(errno));
	close(fd);
	return NULL;
    }
    if ((stbuf.st_mode & S_IFMT)!=fmt)
    {
    	do_log("%s not a regular file, aborting", fname);
	close(fd);
	return NULL;
    }
    if ((res=fdopen(fd, "r"))==NULL)
    {
	close(fd);
	do_log("Trouble: fdopen failed for %s", fname);
    }
    return res;
}
