/* $Id: sockmatch.c,v 1.2 2000/10/10 22:10:44 dps Exp $ */

#ifndef HAVE_CONFIG_H
#include "config.h"
#endif /* HAVE_CONFIG_H */
#ifndef HAVE_STRING_H
#include <string.h>
#endif /* HAVE_STRING_H */
#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif /* HAVE_STRINGS_H */
#ifndef HAVE_SYS_SOCKET_H
#include <sys/socket.h>
#endif /* HAVE_SYS_SOCKET_H */

#include "socklist.h"

void socklist_setval(socklist *scan, int v)
{
    while (scan!=NULL)
    {
	scan->macthval=v;
	scan=scan->next;
    }
    return;
}


/* Remove a socket from a list. Return matchval if found and 0 o.w. */
static int socklist_match_remove(socklist **src, const socklist *sp)
{
    __sock_list **linkp, *scan;
    int ret;

    linkp=src;
    scan=*src;
    while(scan!=NULL)
    {
	if ((scan->fam!=sp->fam) || (scan->type!=sp->type) ||
	    (memcmp(scan->src, sp->src, sizeof(struct sockaddr))!=0) ||
	    (memcmp(scan->dest, sp->dest, sizeof(struct sockaddr))!=0))
	{
	    linkp=&(scan->next);
	    scan=scan->next;
	    continue;
	}
	ret=scan->matchval;
	*linkp=scan->next;
	free_sock(scan);
	return ret;
    }
    return 0;			/* No match */
}

socklist *socklist_aggregate(socklist *s1, socklist *s2)
{
    socklist *list_top, *scan, **scanp;
    int v;

    /* Remove all items in both list from s1 update their values */
    scan=s2;
    while(scan!=NULL)
    {
	v=socklist_match_remove(s1, scan);
	scan->matchval |= v;
	scan=scan->next;
    }
    
    /* Find end pointer of remainder of s2 */
    scan=s1;
    list_top=s1;
    scanp=&list_top;
    while(scan!=NULL)
    {
	scanp=&(scan->next);
	scan=scan->next;
    }
    *scanp=s2;			/* Attach s1 to s2 */
    return list_top;		/* Output list is s2 */
}
