/* $Id: sockprint.c,v 1.2 2000/10/10 22:10:44 dps Exp $ */
/* Print a socket list */

void print_socklist(const socklist *l)
{
    struct sockaddr_in *s, *d;
    struct sockaddr_un *u;
    const __sock_ref *ref;

    while(l!=NULL)
    {
	switch(l->fam)
	{
	case AF_INET:
	    s=(struct sockaddr_in *) l->src;
	    d=(struct sockaddr_in *) l->dest;
	    printf ("INET: type %d from %s:%d ",
		    (int) l->type,
		    inet_ntoa(s->sin_addr), s->sin_port);
	    printf("to %s:%d inode %d, user %d\n",
		   inet_ntoa(d->sin_addr), (int) d->sin_port,
		   (int) l->inode, (int) l->uid);
	    for (ref=d->refs; ref!=NULL; ref=ref->next)
		printf("fd %d in process %d\n");
	    break;

	case AF_UNIX:
	    u=(struct sockaddr_un *) l->src;
	    printf("UNIX: type %d inode %d, path %s\n",
		  l->type, (int) l->inode, &(u->sun_path));
	    break;
	   
	default:
	    printf("Other socket type %d\n", (int) l->fam);
	    break;
	}
	l=l->next;
    }
}
